/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef glow_tracedata_h
#define glow_tracedata_h

#include <string.h>
#include "glow.h"
#include "pwr_privilege.h"

typedef pwr_mAccess glow_mAccess;
#define glow_mAccess_RtDefault pwr_mAccess_RtDefault

class GlowTraceData {
  public:
    GlowTraceData() : attr_type(glow_eTraceType_Boolean),
	color(glow_eDrawType_Inherit), color2(glow_eDrawType_Inherit),
        p(NULL), access(glow_mAccess_RtDefault), cycle(glow_eCycle_Inherit)
	{
	  strcpy( data[0], "");
	  strcpy( data[1], "");
	  strcpy( data[2], "");
	  strcpy( data[3], "");
	  strcpy( data[4], "");
	  strcpy( data[5], "");
	  strcpy( data[6], "");
	  strcpy( data[7], "");
	  strcpy( data[8], "");
	  strcpy( data[9], "");
	  strcpy( ref_object, "");
	};

    char		data[10][120];
    glow_eTraceType	attr_type;
    glow_eDrawType	color;
    glow_eDrawType	color2;
    void		*p;
    glow_mAccess	access;
    glow_eCycle         cycle;
    char                ref_object[120];
};
#endif
